/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */

package org.apache.wink.itest.carstorage;

import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.Response;
import javax.ws.rs.core.UriInfo;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@Path(value = "/carferry")
public class CarFerry extends ParkingGarage {

    Logger            logger = LoggerFactory.getLogger(CarFerry.class);

    @Context
    protected UriInfo uriInfo;

    public Response addCar(String licenseNum) {
        super.setURIInfo(uriInfo);
        Response resp = super.addCar(licenseNum);
        resp.getMetadata().putSingle("Invoked", "CarFerry.addCar");
        return resp;
    }

    public Response getCars() {
        super.setURIInfo(uriInfo);
        Response resp = super.getCars();
        resp.getMetadata().putSingle("Invoked", "CarFerry.getCars");
        return resp;
    }

    @GET
    public Response removeCar(String licenseNum) {
        super.setURIInfo(uriInfo);
        Response resp = super.getCars();
        resp.getMetadata().putSingle("Invoked", "CarFerry.removeCar");
        return resp;
    }
}
